 /*
    This program starts up two threads that each repeatedly
    print a single character to standard output, one thread
    outputs '.' and the other thread outputs '#'. The threads
    are run at different priorities. Notice that the higher
    priority thread gets the CPU most of the time, but the
    scheduler gives the low priority thread the CPU every once
    in a while.

    When you run this program, use Quick Slice (qslice.exe) to
    observe this program's threads. As this program runs, do a
    bunch of things with other programs, start them up, close
    them. Be sure to also switch this process between foreground
    and background. Also, you can temporarily stop this process's
    threads by clicking in this process's console window. Restart
    the threads by hitting the Enter key. What happens when the
    threads start back up again?

    Also try the alternate combination of priorities that is commented
    out below.

    Modify this program to dynamically (every few seconds) change the
    priority of one of the threads. Or try adding more threads, at various
    priorities, to this program.
*/
#include <windows.h>
#include <stdio.h>

int main()
{
   //thread function prototypes
   DWORD WINAPI thread1(LPVOID);
   DWORD WINAPI thread2(LPVOID);

   HANDLE thread1Handle;
   HANDLE thread2Handle;

   // create the threads (but do not let them run yet)
   // (note that these function calls have no error checking)
   thread1Handle = CreateThread(NULL, 0, thread1, 0, CREATE_SUSPENDED, NULL);
   thread2Handle = CreateThread(NULL, 0, thread2, 0, CREATE_SUSPENDED, NULL);

   // set the priority of the (suspended) threads
   SetThreadPriority(thread1Handle, THREAD_PRIORITY_ABOVE_NORMAL);
   SetThreadPriority(thread2Handle, THREAD_PRIORITY_NORMAL);

   // also try the following combination of priorities
   //SetThreadPriority(thread1Handle, THREAD_PRIORITY_NORMAL);
   //SetThreadPriority(thread2Handle, THREAD_PRIORITY_BELOW_NORMAL);

   // now start the threads
   printf("Starting threads\n");
   ResumeThread(thread1Handle);
   ResumeThread(thread2Handle);

   while(1) // loop forever
   {
      Sleep(1000);  // try commenting out this line
   }

   return 0;
}//main


DWORD WINAPI thread1(LPVOID threadParam)
{
   while(1) // loop forever
   {
      printf(".");
   }
   return 0;
}//thread1


DWORD WINAPI thread2(LPVOID threadParam)
{
   while(1) // loop forever
   {
      printf("#");
   }
   return 0;
}//thread2
