/*
    This program calls the "thread functions" as threads,
    that is, they are called concurrently. Notice that this
    program has three threads. The main thread blocks on
    WaitForMultipleObjects() in order to wait for the child
    threads to complete.

    Run this program many times. You should see different
    interleavings of the output strings.
*/
#include <stdio.h>
#include <windows.h>

// function prototypes
DWORD WINAPI thread1(LPVOID);
DWORD WINAPI thread2(LPVOID);

int main()
{
   HANDLE hthread[2];

   // create the threads
   hthread[0] = CreateThread(NULL, 0, thread1, 0, 0, NULL);  // should have error checking
   hthread[1] = CreateThread(NULL, 0, thread2, 0, 0, NULL);

   // wait for the threads to finish
   WaitForMultipleObjects(2, hthread, TRUE, INFINITE);

   fprintf(stderr, "\nAll done.\n");

   return 0;
}


DWORD WINAPI thread1(LPVOID vargp) // vargp means "variable (length) argument pointer"
{
    fprintf(stderr, "hello ");
    Sleep(1000);    // try Sleep(0)
    fprintf(stderr, "from thread 1!\n");
    return 0;
}


DWORD WINAPI thread2(LPVOID vargp)
{
    fprintf(stderr, "HELLO FROM ");
    Sleep(1000);    // try Sleep(0)
    fprintf(stderr, "THREAD 2?\n");
    return 0;
}
