/*
    This program calls one of the "thread functions" as a
    thread and the other "thread function" as a regular
    function. Notice that this program has two threads,
    the main thread and one child thread. The two functions
    run concurrently, one in each thread. The main thread
    blocks on WaitForMultipleObjects() in order to wait for
    the child thread to complete.

    Run this program many times. You should see different
    interleavings of the output strings.
*/
#include <stdio.h>
#include <windows.h>

// function prototypes
DWORD WINAPI thread1(LPVOID);
DWORD WINAPI thread2(LPVOID);

int main()
{
   HANDLE hthread[1];

   // create the thread
   hthread[0] = CreateThread(NULL, 0, thread1, 0, 0, NULL);  // should have error checking

   // call the function
   thread2(NULL);

   // wait for the thread to finish
   WaitForMultipleObjects(1, hthread, TRUE, INFINITE);

   fprintf(stderr, "\nAll done.\n");

   return 0;
}


DWORD WINAPI thread1(LPVOID vargp) // vargp means "variable (length) argument pointer"
{
    fprintf(stderr, "hello ");
    Sleep(1000);    // try Sleep(0)
    fprintf(stderr, "from thread 1!\n");
    return 0;
}


DWORD WINAPI thread2(LPVOID vargp)
{
    fprintf(stderr, "HELLO FROM ");
    Sleep(1000);    // try Sleep(0)
    fprintf(stderr, "THREAD 2?\n");
    return 0;
}
