/*
    This program calls the "thread functions" as regular functions,
    that is, they are called sequentially.

    This program passes parameters (by reference) to the "thread functions".
    The pointers to the parameters are on the (main thread's) stack.
*/
#include <stdio.h>
#include <windows.h>

// function prototypes
DWORD WINAPI thread1(LPVOID);
DWORD WINAPI thread2(LPVOID);

int main()
{
   int arg1 = 101;
   int arg2 = 202;

   fprintf(stderr, "Address of arg1 = %d\n", (int)&arg1);
   fprintf(stderr, "Address of arg2 = %d\n\n", (int)&arg2);

   thread1(&arg1);
   thread2(&arg2);

   fprintf(stderr, "\nAll done.\n");

   return 0;
}


DWORD WINAPI thread1(LPVOID vargp)  // vargp means "variable (length) argument pointer"
{
   int arg = *((int*)vargp);  // the "void pointer" needs to be cast back into an int pointer

   fprintf(stderr, "hello ");

   Sleep(1000);
   fprintf(stderr, "from thread 1 with argument %d ", arg);

   Sleep(1000);
   fprintf(stderr, "(vargp = %d and &vargp =  %d).\n", (int)vargp, (int)&vargp);
   return 0;
}


DWORD WINAPI thread2(LPVOID vargp)
{
   int arg = *((int*)vargp);

   fprintf(stderr, "HELLO FROM ");

   Sleep(1000);
   fprintf(stderr, "THREAD 2 WITH ARGUMENT %d ", arg);

   Sleep(1000);
   fprintf(stderr, "(vargp = %d AND &vargp =  %d).\n", (int)vargp, (int)&vargp);
   return 0;
}
