/*
    This program calls the "thread functions" as regular functions,
    that is, they are called sequentially.

    This program passes parameters (by reference) to the "thread functions".
    The pointers to the parameters are on the (main thread's) stack.
*/
#include <stdio.h>    // fprintf(), stderr
#include <unistd.h>   // posix, sleep()
#include <windows.h>  // win32, Sleep()
#include <pthread.h>

// function prototypes
void *thread1(void *vargp);
void *thread2(void *vargp);

int main()
{
   int arg1 = 101;
   int arg2 = 202;

   fprintf(stderr, "Address of arg1 = %d\n", (int)&arg1);
   fprintf(stderr, "Address of arg2 = %d\n\n", (int)&arg2);

   thread1(&arg1);
   thread2(&arg2);

   fprintf(stderr, "\nAll done.\n");

   return 0;
}


void *thread1(void *vargp)  // vargp means "variable (length) argument pointer"
{
   int arg = *((int*)vargp); // the "void pointer" needs to be cast back into an int pointer

   fprintf(stderr, "hello ");
   //sleep(1);  // posix
   Sleep(1000); // win32
   fprintf(stderr, "from thread 1 with argument %d ", arg);
   //sleep(1);  // posix
   Sleep(1000); // win32
   fprintf(stderr, "(vargp = %d and &vargp =  %d).\n", (int)vargp, (int)&vargp);
   return NULL;
}


void *thread2(void *vargp)
{
   int arg = *((int*)vargp);

   fprintf(stderr, "HELLO FROM ");
   //sleep(1);  // posix
   Sleep(1000); // win32
   fprintf(stderr, "THREAD 2 WITH ARGUMENT %d ", arg);
   //sleep(1);  // posix
   Sleep(1000); // win32
   fprintf(stderr, "(vargp = %d AND &vargp =  %d).\n", (int)vargp, (int)&vargp);
   return NULL;
}
