/*
   This version uses a thread to display the message box. Each display
   thread blocks until the user clicks the "OK" button in its message box.
   But the main thread of the application does not block, so the program's
   user can keep on entering numbers, even while a message box is displayed.
*/
#include <windows.h>  // win32
#include <stdio.h>
#include <pthread.h>

// function prototype
void *displayMessageBox(void *vargp);

int main()
{
   int number;  pthread_t tid;
   while(1)
   {
      printf("Please enter a number: ");
      scanf("%d", &number);
      // create a thread to display the message box
      pthread_create(&tid, NULL, displayMessageBox, &number);  // should have error checking
   }
   return 0;  // the main function never returns
}//main


void *displayMessageBox(void *vargp)
{
   int number = *(int*)vargp;
   char titleText[] = "Here is what you entered";
   char messageText[20];
   sprintf(messageText, "Your number is %d.", number);
   MessageBox(NULL, messageText, titleText, MB_OK | MB_ICONINFORMATION | MB_TOPMOST);
   return 0;
}//displayMessageBox
